# coding: utf-8
# -------------------------------------------------------------------
# Lambdas.rb
# versión 1.0
# Copyright (C) 2016  José Ricardo Rodríguez Abreu.
# Facultad de Ciencias,
# Universidad Nacional Autónoma de México, Mexico.
#
# Este programa es software libre; se puede redistribuir
# y/o modificar en los términos establecidos por la
# Licencia Pública General de GNU tal como fue publicada
# por la Free Software Foundation en la versión 2 o
# superior.
#
# Este programa es distribuido con la esperanza de que
# resulte de utilidad, pero SIN GARANTÍA ALGUNA; de hecho
# sin la garantía implícita de COMERCIALIZACIÓN o
# ADECUACIÓN PARA PROPÓSITOS PARTICULARES. Véase la
# Licencia Pública General de GNU para mayores detalles.
#
# Con este programa se debe haber recibido una copia de la
# Licencia Pública General de GNU, de no ser así, visite el
# siguiente URL:
# http://www.gnu.org/licenses/gpl.html
# o escriba a la Free Software Foundation Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# -------------------------------------------------------------------

var_a = nil
lambda_0 = lambda { if var_a == nil
                      var_a = 5 + 5
                    else
                      var_a += var_a
                    end }
lambda_1 = lambda { lambda_0.call() + lambda_0.call() }
lambda_2 = lambda { lambda { lambda_1.call() + lambda_1.call() } }
# Es una función que nos genera un  ciclo infinito.
lambda_3 = lambda { while true do
                      p var_a
                      var_a += var_a
                    end }

var_a = lambda_2.call()

if var_a == 10
  puts "Ciclo infinito! Oh no!"
  lambda_3.call()
elsif var_a == 150
  puts("Ups!")
  lambda_3.call()
else
  puts "¿Qué pasó?"
end
