# coding: utf-8
# -------------------------------------------------------------------
# Ejemplo.rb
# versión 1.0
# Copyright (C) 2016  José Ricardo Rodríguez Abreu.
# Facultad de Ciencias,
# Universidad Nacional Autónoma de México, Mexico.
#
# Este programa es software libre; se puede redistribuir
# y/o modificar en los términos establecidos por la
# Licencia Pública General de GNU tal como fue publicada
# por la Free Software Foundation en la versión 2 o
# superior.
#
# Este programa es distribuido con la esperanza de que
# resulte de utilidad, pero SIN GARANTÍA ALGUNA; de hecho
# sin la garantía implícita de COMERCIALIZACIÓN o
# ADECUACIÓN PARA PROPÓSITOS PARTICULARES. Véase la
# Licencia Pública General de GNU para mayores detalles.
#
# Con este programa se debe haber recibido una copia de la
# Licencia Pública General de GNU, de no ser así, visite el
# siguiente URL:
# http://www.gnu.org/licenses/gpl.html
# o escriba a la Free Software Foundation Inc.,
# 59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.
# -------------------------------------------------------------------

require 'lazy'

# Función que realmente no hace nada interesante.
def fun(a, b, random)
  c = promise { b*-1 }
  d = promise { a+b+c }
  e = promise { d*2 }
  f = promise { a*random.rand(100) }
  g = promise { (b-1)*random.rand(100) }
  if (g-f) == 1
    return 1
  else
    # Este return sí es válido en Ruby:
    # regresa un arreglo con todos los parametros que le reciba en return.
    return demand(a),b,c*2,d,e,f,g
  end
end

a = promise { 5*2 }
b = promise { a+2 }
r = promise { Random.new }

# Usamos la función "p foo" porque imprime "foo.inspect" en lugar de "foo.to_s".
p fun(a, b, r)
